
 pure function deriv(t,lambda,xi)
   implicit none
   real,intent(IN) :: t
   real,intent(IN) :: lambda
   real,intent(IN),dimension(2) :: xi
   real,dimension(2) :: deriv
   real :: x,y
   
   integer,parameter :: ikind = selected_real_kind(p=16,r=20)
   real(kind=ikind), parameter ::  pi=3.141592653589793238462643d0
   real(kind=ikind), parameter :: sq2=1.4142135623730950488
   real(kind=ikind), parameter :: t3s8pi=2.4142135623730950488
   real(kind=ikind), parameter :: t9s8pi=0.4142135623730950488

          x=xi(1)
          y=xi(2)
          if (x>=0. .and. y<=0.) then
  deriv=(/ x , y /)				!S1
elseif (x>0. .and. y<=t3s8pi*x) then
  deriv = (/ x-sq2*y , (sq2-1.)*y /)		!S2
elseif (y>0. .and. y>t3s8pi*x .and. y>-x) then
  deriv = (/ -sq2*x +(1.-sq2)*y , real(x,kind=ikind) /)	!S3
elseif (x<0. .and.  y < t9s8pi*x) then
  deriv = (/ (sq2-1.)*x , -sq2*x+y /)		!S5
else 
  deriv = (/ real(y,kind=ikind) , (1.-sq2)*x -sq2*y /) 	!S4
endif
 end function deriv

